package com.mints.goodmoney.manager;

import android.app.Application;
import android.app.Dialog;
import android.content.DialogInterface;
import android.view.View;

import androidx.appcompat.app.AlertDialog;

import com.chineseall.reader.lib.reader.callbacks.OnAdViewReceiver;
import com.chineseall.reader17ksdk.ChineseAllReaderApplication;
import com.chineseall.reader17ksdk.callbacks.AdProvider;
import com.chineseall.reader17ksdk.callbacks.OnReadCallBack;
import com.chineseall.reader17ksdk.utils.ActivityStackManager;
import com.chineseall.reader17ksdk.utils.DensityUtil;
import com.chineseall.reader17ksdk.utils.NetworkUtil;
import com.chineseall.reader17ksdk.utils.ToastUtil;
import com.chineseall.reader17ksdk.utils.book.ScreenUtils;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Map;

import kotlin.Unit;
import kotlin.jvm.functions.Function0;

/**
 * 中文在线 听读
 * 作者：孟崔广
 * 时间：2021/04/08 14:44
 * 邮箱：mengcga@163.com
 */
public class ReaderManager {

    public static void init(Application applicationContext) {
        ToutiaoAD csjAd = new ToutiaoAD();
        ChineseAllReaderApplication.Companion.install(applicationContext, "1242", "hzq@1242", "32", "0", new AdProvider() {

            /**
             * 阅读⻚弹窗广告确认按钮的点击回调-激励视频
             * @param dialog
             * @param block 对话框关闭回调，必须调用，否则计时每次切换章节都会出现弹窗
             */
            @Override
            public void onAdDialogPositiveClick(@Nullable Dialog dialog, @NotNull Function0<Unit> function0) {
                if (NetworkUtil.isNetworkAvailable(applicationContext) && !NetworkUtil.INSTANCE.isWifiConnected(applicationContext)) {
                    new AlertDialog.Builder(ActivityStackManager.getInstance().getTopActivity())
                            .setTitle("温馨提示")
                            .setMessage("当前处于移动网络，播放视频会消耗流量，确定播放？")
                            .setPositiveButton("观看视频", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    csjAd.showVideo(ActivityStackManager.getInstance().getTopActivity(), new ToutiaoAD.OnVideoCloseCallBack() {
                                        @Override
                                        public void onClose() {
                                            function0.invoke();
                                        }
                                    });
                                }
                            }).setNegativeButton("取消", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                        }
                    }).create().show();
                    return;
                }else{
                    csjAd.showVideo(ActivityStackManager.getInstance().getTopActivity(), new ToutiaoAD.OnVideoCloseCallBack() {
                        @Override
                        public void onClose() {
                            function0.invoke();
                        }
                    });
                }

            }

            /**
             * 阅读⻚首次打开 弹框广告(信息流) 广告宽度 320 高度 260 * @param adViewContainer 广告view的容器
             */
            @Override
            public void getReaderScreenAd(@NotNull View view, @NotNull OnAdViewReceiver receiver,
                                          @Nullable Dialog dialog) {
                csjAd.loadAD(applicationContext, receiver, 320, 260, new ToutiaoAD.OnClickListener() {
                    @Override
                    public void onClick() {
                        dialog.dismiss();
                    }
                });
            }

            /**
             * 阅读⻚翻⻚广告(信息流) 广告宽度 320 高度 260 */
            @Override
            public void getReaderPageAd(@NotNull OnAdViewReceiver receiver) {
                csjAd.loadAD(applicationContext, receiver, DensityUtil.px2dip(applicationContext, ScreenUtils.getScreenWidth(applicationContext) - DensityUtil.dip2px(applicationContext, 30f)), DensityUtil.px2dip(applicationContext, 854f), null);

            }

            /**
             * 阅读⻚定时弹窗广告 (激励视频)
             */
            @Override
            public void getReaderDialogAd(@NotNull View view, @NotNull OnAdViewReceiver receiver, @Nullable Dialog dialog) {
                csjAd.loadVideoAd(ActivityStackManager.getInstance().getTopActivity(), receiver);
            }
        });

    }
}
