package com.mints.goodmoney.manager;

import android.app.Activity;
import android.content.Context;
import android.view.View;
import android.widget.Toast;

import com.bytedance.sdk.openadsdk.AdSlot;
import com.bytedance.sdk.openadsdk.TTAdConstant;
import com.bytedance.sdk.openadsdk.TTAdNative;
import com.bytedance.sdk.openadsdk.TTAdSdk;
import com.bytedance.sdk.openadsdk.TTAppDownloadListener;
import com.bytedance.sdk.openadsdk.TTFeedAd;
import com.bytedance.sdk.openadsdk.TTImage;
import com.bytedance.sdk.openadsdk.TTNativeExpressAd;
import com.bytedance.sdk.openadsdk.TTRewardVideoAd;
import com.chineseall.reader.lib.reader.callbacks.OnAdViewReceiver;
import com.chineseall.reader17ksdk.ChineseAllReaderApplication;
import com.chineseall.reader17ksdk.aop.AspectTest;
import com.chineseall.reader17ksdk.utils.LogUtils;
import com.chineseall.reader17ksdk.utils.book.ScreenUtils;
import com.mints.library.utils.json.JsonUtil;

import java.util.List;


public class ToutiaoAD {

    private static final String tag = "ToutiaoAD";

    /*
    开屏和信息流都用此
     */
    //开屏广告加载超时时间,建议大于200
    private static final int AD_TIME_OUT = 3000;
    private TTAdNative mTTAdNative;
    private Context context;

    private TTFeedAd feedAd;        //信息流回调类
    private TTRewardVideoAd mttRewardVideoAd;
    private View mView;

    public String getIcon() {
        if (feedAd == null) {
            return null;
        }
        TTImage ttImage = feedAd.getIcon();
        if (ttImage != null && ttImage.getImageUrl() != null) {
            return ttImage.getImageUrl();
        }
        return null;
    }

    public String getImage() {
        if (feedAd == null) {
            return null;
        }
        List<TTImage> list = feedAd.getImageList();
        if (list != null && list.size() > 0) {
            TTImage ttImage = list.get(0);
            if (ttImage != null && ttImage.getImageUrl() != null) {
                return ttImage.getImageUrl();
            }
        }
        return null;
    }

    public String getTitle() {
        if (feedAd == null) {
            return null;
        }
        return feedAd.getTitle();
    }

    public String getDesc() {
        if (feedAd == null) {
            return null;
        }
        return feedAd.getDescription();
    }

    public String getUrl() {
        return null;
    }

    public boolean isApp() {
        return false;
    }

    public View getView() {
        return mView;
    }

    public List<String> getImageList() {
        return null;
    }


    //    @Override
    public void loadAD(final Context context, OnAdViewReceiver receiver, int width, int height, OnClickListener listener) {
        this.context = context;

        LogUtils.d(tag, "load ad");

        if (mTTAdNative == null) {
            mTTAdNative = TtCsjAdManager.get().createAdNative(context);
        }
//        if (ADConfig.TYPE_NATIVE.equals(adParamers.type)){
        //信息流
//            initNativeAD();
//        }else if(ADConfig.TYPE_SPLASH.equals(adParamers.type)){
//            开屏
//            initSplashAD();
//        }else if(ADConfig.TYPE_INTERSTITIAL.equals(adParamers.type)){
        //插屏广告
//            initInteractionAD((Activity) context);
//        }else if (ADConfig.TYPE_VIDEO.equals(adParamers.type)){
//            initVedioAD(context);
//        }else if (ADConfig.TYPE_FEED.equals(adParamers.type)){
        initFeedAD(receiver, width, height, listener);
//        }

    }

    public void loadVideoAd(Context context, OnAdViewReceiver receiver) {
        this.context = context;

        if (mTTAdNative == null) {
            mTTAdNative = TtCsjAdManager.get().createAdNative(context);
        }
        initVedioAD(context, receiver);
    }

    private void initFeedAD(OnAdViewReceiver receiver, int width, int height, OnClickListener clickListener) {

        // DensityUtil.px2dip(context, ScreenUtils.getScreenWidth(context) - DensityUtil.dip2px(context, 30)), DensityUtil.px2dip(context, 854)
        //设置广告参数
        AdSlot adSlot = new AdSlot.Builder()
                .setCodeId(TtCsjAdManager.TT_AD_NATIVEEXPRESS_WALK) //广告位id
                .setSupportDeepLink(true)
                .setAdCount(1) //请求广告数量为1到3条
                .setExpressViewAcceptedSize(width, height) //必填：期望个性化模板广告view的size,单位dp
                .setImageAcceptedSize(400, 150) //这个参数设置即可，不影响个性化模板广告的size
                .build();
        mTTAdNative.loadNativeExpressAd(adSlot, new TTAdNative.NativeExpressAdListener() {
            @Override
            public void onError(int code, String message) {
                LogUtils.d(tag, "code: " + code + ", " + message);
                receiver.onReceive(false, null);
//                TToast.show(NativeExpressActivity.this, "load error : " + code + ", " + message);
//                getAdParamers().parent.removeAllViews();
            }

            @Override
            public void onNativeExpressAdLoad(List<TTNativeExpressAd> ads) {
                if (ads == null || ads.size() == 0) {
                    return;
                }
                LogUtils.d(tag, "onNativeExpressAdLoad : " + ads.size());
                TTNativeExpressAd mTTAd = ads.get(0);
                bindAdListener(mTTAd, receiver, clickListener);
                mTTAd.render();//调用render开始渲染广告
            }
        });
    }

    //绑定广告行为
    private void bindAdListener(TTNativeExpressAd ad, OnAdViewReceiver receiver, OnClickListener clickListener) {
        ad.setExpressInteractionListener(new TTNativeExpressAd.ExpressAdInteractionListener() {
            @Override
            public void onAdClicked(View view, int type) {
                LogUtils.d(tag, "onAdClicked : " + type);
                LogUtils.d("onAdClicked");
                if (clickListener != null) {
                    clickListener.onClick();
                }
            }

            @Override
            public void onAdShow(View view, int type) {
                LogUtils.d(tag, "onAdShow : " + type);
                LogUtils.d("onAdShow");
            }

            @Override
            public void onRenderFail(View view, String msg, int code) {
                LogUtils.d(tag, "onRenderFail : " + msg + ", " + code);
                receiver.onReceive(false, view);
            }

            @Override
            public void onRenderSuccess(View view, float width, float height) {
                LogUtils.d(tag, "onRenderSuccess : " + view.getClass().getName());
                //返回view的宽高 单位 dp
                //在渲染成功回调时展示广告，提升体验
//                getAdParamers().parent.removeAllViews();
//                getAdParamers().parent.addView(view);
                mView = view;
                if (mView != null && !AspectTest.views.contains(view.getClass().getName())) {
                    AspectTest.views.add(view.getClass().getName());
                }
                receiver.onReceive(true, view);
//                adParamers.listener.onADLoaded(com.rice.gluepudding.ad.impl.ToutiaoAD.this);
            }
        });
        //dislike设置
//        bindDislike(ad, false);
        if (ad.getInteractionType() != TTAdConstant.INTERACTION_TYPE_DOWNLOAD) {
            return;
        }
        //可选，下载监听设置
        ad.setDownloadListener(new TTAppDownloadListener() {
            @Override
            public void onIdle() {
                LogUtils.d(tag, "onIdle : ");
//                TToast.show(NativeExpressActivity.this, "点击开始下载", Toast.LENGTH_LONG);
            }

            @Override
            public void onDownloadActive(long totalBytes, long currBytes, String fileName, String appName) {
                LogUtils.d(tag, "onDownloadActive : ");
//                if (!mHasShowDownloadActive) {
//                    mHasShowDownloadActive = true;
//                    TToast.show(NativeExpressActivity.this, "下载中，点击暂停", Toast.LENGTH_LONG);
//                }
            }

            @Override
            public void onDownloadPaused(long totalBytes, long currBytes, String fileName, String appName) {
                LogUtils.d(tag, "onDownloadPaused : ");
//                TToast.show(NativeExpressActivity.this, "下载暂停，点击继续", Toast.LENGTH_LONG);
            }

            @Override
            public void onDownloadFailed(long totalBytes, long currBytes, String fileName, String appName) {
                LogUtils.d(tag, "onDownloadFailed : ");
//                TToast.show(NativeExpressActivity.this, "下载失败，点击重新下载", Toast.LENGTH_LONG);
            }

            @Override
            public void onInstalled(String fileName, String appName) {
                LogUtils.d(tag, "onInstalled : ");
//                TToast.show(NativeExpressActivity.this, "安装完成，点击图片打开", Toast.LENGTH_LONG);
            }

            @Override
            public void onDownloadFinished(long totalBytes, String fileName, String appName) {
                LogUtils.d(tag, "onDownloadFinished : ");
//                TToast.show(NativeExpressActivity.this, "点击安装", Toast.LENGTH_LONG);
            }
        });
    }

    private void initVedioAD(final Context context, OnAdViewReceiver receiver) {
//        SharedPreferencesUtil.getInstance().putBoolean(StringConstants.VIDEO_TASK_FINISH, false);
        AdSlot adSlot = new AdSlot.Builder()
                .setCodeId(TtCsjAdManager.TT_AD_VEDIO_READ)
                .setSupportDeepLink(true)
                //个性化模板广告需要设置期望个性化模板广告的大小,单位dp,激励视频场景，只要设置的值大于0即可。仅模板广告需要设置此参数
                .setExpressViewAcceptedSize(500, 500)
                .setImageAcceptedSize(1080, 1920)
                .setUserID(UserManager.getInstance().getUserID())//用户id,必传参数
                .setMediaExtra("media_extra")
                .setOrientation(TTAdConstant.VERTICAL)
                .build();
        mTTAdNative.loadRewardVideoAd(adSlot, new TTAdNative.RewardVideoAdListener() {
            @Override
            public void onError(int code, String message) {
                LogUtils.i("ToutiaoAd", message);
//                adParamers.listener.onAdFailed("error");
                receiver.onReceive(false, null);

            }

            //视频广告加载后的视频文件资源缓存到本地的回调
            @Override
            public void onRewardVideoCached() {
                LogUtils.i("ToutiaoAd", "rewardVideoAd video cached");
            }

            //视频广告素材加载到，如title,视频url等，不包括视频文件
            @Override
            public void onRewardVideoAdLoad(TTRewardVideoAd ad) {
//                    Log.i("ToutiaoAd","rewardVideoAd loaded");
                mttRewardVideoAd = ad;
                receiver.onReceive(true, null);
                //mttRewardVideoAd.setShowDownLoadBar(false);
            }
        });
    }

    public void showVideo(Context context, OnVideoCloseCallBack callBack) {
        if (mttRewardVideoAd != null) {
            mttRewardVideoAd.setRewardAdInteractionListener(new TTRewardVideoAd.RewardAdInteractionListener() {

                @Override
                public void onAdShow() {
                    LogUtils.i("ToutiaoAd", "rewardVideoAd onAdShow");
//                        adParamers.listener.onADLoaded(com.rice.gluepudding.ad.impl.ToutiaoAD.this);
                }

                @Override
                public void onAdVideoBarClick() {
                    LogUtils.i("ToutiaoAd", "rewardVideoAd onAdVideoBarClick");
//                        adParamers.listener.onAdClick();
                }

                @Override
                public void onAdClose() {
                    LogUtils.i("ToutiaoAd", "rewardVideoAd onAdClose");
                    if (callBack != null) {
                        callBack.onClose();
                    }
//                        adParamers.listener.onAdDismiss();
//                        EventBus.getDefault().post(new ADCloseEvent(SharedPreferencesUtil.getInstance().getInt(StringConstants.LOOK_VEDIO_TYPE, LOOK_VEDIO_AD_TYPE.NORMAL)));

                }

                @Override
                public void onVideoComplete() {
                    LogUtils.i("ToutiaoAd", "rewardVideoAd complete");
//                        Toast.makeText(context,"恭喜您，观看完毕！",Toast.LENGTH_SHORT).show();
                }

                @Override
                public void onVideoError() {
                    LogUtils.i("ToutiaoAd", "rewardVideoAd onVideoError");
//                        if (com.burst.ad_toutiao_lib.BuildConfig.DEBUG){
                    Toast.makeText(context, "视频播放错误", Toast.LENGTH_SHORT).show();
//                        }
                }

                @Override
                public void onRewardVerify(boolean b, int i, String s, int i1, String s1) {

                }

                @Override
                public void onSkippedVideo() {

                }
            });
            mttRewardVideoAd.setDownloadListener(new TTAppDownloadListener() {
                @Override
                public void onIdle() {

                }

                @Override
                public void onDownloadActive(long totalBytes, long currBytes, String fileName, String appName) {

                }

                @Override
                public void onDownloadPaused(long totalBytes, long currBytes, String fileName, String appName) {

                }

                @Override
                public void onDownloadFailed(long totalBytes, long currBytes, String fileName, String appName) {

                }

                @Override
                public void onDownloadFinished(long totalBytes, String fileName, String appName) {

                }

                @Override
                public void onInstalled(String fileName, String appName) {

                }
            });
            mttRewardVideoAd.showRewardVideoAd((Activity) context);
        }
    }

    public interface OnVideoCloseCallBack {
        void onClose();
    }

    public interface OnClickListener {
        void onClick();
    }

//    private void initInteractionAD(final Activity context) {
//        //插屏广告请求类型数据
//        AdSlot adSlot = new AdSlot.Builder()
//                .setCodeId(adParamers.key)
//                .setSupportDeepLink(true)
//                .setImageAcceptedSize(600, 600)
//                .build();
//        //调用插屏广告异步请求接口
//        mTTAdNative.loadInteractionAd(adSlot, new TTAdNative.InteractionAdListener() {
//            @Override
//            public void onError(int i, String s) {
//
//            }
//
//            @Override
//            public void onInteractionAdLoad(TTInteractionAd ttInteractionAd) {
//                ttInteractionAd.setAdInteractionListener(new TTInteractionAd.AdInteractionListener() {
//                    @Override
//                    public void onAdClicked() {
//                        adParamers.listener.onAdClick();
//                    }
//
//                    @Override
//                    public void onAdShow() {
//                        adParamers.listener.onADLoaded(com.rice.gluepudding.ad.impl.ToutiaoAD.this);
//                    }
//
//                    @Override
//                    public void onAdDismiss() {
//
//                    }
//                });
//                //弹出插屏广告
//                ttInteractionAd.showInteractionAd(context);
//            }
//        });
//    }
//
//    private void initSplashAD() {
//        //开屏广告参数
//        AdSlot adSlot = new AdSlot.Builder()
//                .setCodeId(adParamers.key)
//                .setSupportDeepLink(true)
//                .setImageAcceptedSize(ScreenUtils.getScreenWidth(), ScreenUtils.getScreenHeight())
//                .build();
//        mTTAdNative.loadSplashAd(adSlot, new TTAdNative.SplashAdListener() {
//            @Override
//            public void onError(int code, String message) {
//                //开屏广告请求失败
//                adParamers.listener.onAdFailed(message);
//            }
//
//            @Override
//            public void onTimeout() {
//                //开屏广告请求超时
//                adParamers.listener.onAdFailed("请求超时了");
//            }
//
//            @Override
//            public void onSplashAdLoad(TTSplashAd ttSplashAd) {
//
//                //开屏广告请求成功了
//                if(ttSplashAd == null){
//                    return;
//                }
//
//                adParamers.listener.onADLoaded(com.rice.gluepudding.ad.impl.ToutiaoAD.this);
//
//                //获取SplashView
//                View view = ttSplashAd.getSplashView();
//                adParamers.parent.removeAllViews();
//                //把SplashView 添加到ViewGroup中
//                adParamers.parent.addView(view);
//
//                //设置不显示SDK自带的跳过和倒计时
//                ttSplashAd.setNotAllowSdkCountdown();
//
//                ttSplashAd.setSplashInteractionListener(new TTSplashAd.AdInteractionListener() {
//                    @Override
//                    public void onAdClicked(View view, int i) {
//                        //广告点击了
//                        adParamers.listener.onAdClick();
//                    }
//
//                    @Override
//                    public void onAdShow(View view, int i) {
//                        //广告显示了
////                            adParamers.listener.onADLoaded(ToutiaoAD.this);
//                    }
//
//                    @Override
//                    public void onAdSkip() {
//                        //广告跳过
//                        adParamers.listener.onAdDismiss();
//                    }
//
//                    @Override
//                    public void onAdTimeOver() {
//                        //开屏广告倒计时结束
//                        adParamers.listener.onAdDismiss();
//                    }
//                });
//            }
//        },AD_TIME_OUT);
//    }

//    private void initNativeAD() {
//        //feed广告请求类型参数
//        AdSlot adSlot = new AdSlot.Builder()
//                .setCodeId(adParamers.key)
//                .setSupportDeepLink(true)
//                .setImageAcceptedSize(640, 320)
//                .setAdCount(1)
//                .build();
//        mTTAdNative.loadFeedAd(adSlot, new TTAdNative.FeedAdListener() {
//            @Override
//            public void onError(int code, String message) {
//                adParamers.listener.onAdFailed(message);
//            }
//
//            @Override
//            public void onFeedAdLoad(List<TTFeedAd> ads) {
//                if(ads != null && ads.size() > 0){
//                    feedAd = ads.get(0);
//                    adParamers.listener.onADLoaded(com.rice.gluepudding.ad.impl.ToutiaoAD.this);
//                }else{
//                    adParamers.listener.onAdFailed("没有广告");
//                }
//            }
//        });
//    }

    //    @Override
    public boolean onExposured(View view) {
//        if (ADConfig.TYPE_NATIVE.equals(adParamers.type)){
        //
//            if(feedAd != null){
//                feedAd.registerViewForInteraction(adParamers.parent, adParamers.clickViewList, null, new TTNativeAd.AdInteractionListener() {
//                    @Override
//                    public void onAdClicked(View view, TTNativeAd ttNativeAd) {
////                        adParamers.listener.onAdClick();
//                    }
//
//                    @Override
//                    public void onAdCreativeClick(View view, TTNativeAd ttNativeAd) {
//
//                    }
//
//                    @Override
//                    public void onAdShow(TTNativeAd ttNativeAd) {
//                        if(ttNativeAd != null){
//                            //广告显示了
////                            adParamers.listener.onAdShow(com.rice.gluepudding.ad.impl.ToutiaoAD.this);
//                        }
//                    }
//                });
//
//            }
//        }
        return false;
    }

    //    @Override
    public boolean onClicked(View view) {
        return false;
    }
}
